﻿Type=Class
Version=1.06
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private anc As AnchorPane
	Private lbl As Label
	Private tf As TextField
	Private Fromlimit As Int = 1400
	Private Tolimit As Int = 2000
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Width As Int, Height As Int)
anc.Initialize("anc")
anc.LoadLayout("Htext.fxml")
anc.PrefWidth = Width
anc.PrefHeight = Height
End Sub

Public Sub SetAppearance(FontSize As Double, Textcolor As Paint,Style As String)
setFontsize(FontSize)
setTextColor(Textcolor)
setStyle(Style)
End Sub

Public Sub AsNode As Node
Return anc
End Sub

Public Sub getText As String
Return tf.Text
End Sub

Public Sub setText(Text As String)
tf.Text = Text
End Sub

Public Sub getStyle As String
Return lbl.Style 
End Sub

Public Sub setStyle(Style As String)
lbl.Style = Style
End Sub

Public Sub getTextColor As Paint
Return lbl.TextColor
End Sub

Public Sub setTextColor(Color As Paint)
lbl.TextColor = Color
End Sub

Public Sub getFontsize As Int
Return lbl.Font.Size
End Sub

Public Sub setFontsize(Fontsize As Int)
lbl.Font = fx.DefaultFont(Fontsize)
End Sub

Public Sub SetLimits(Low As Int, High As Int)
Fromlimit = Low
Tolimit = High
End Sub

Private Sub tf_TextChanged (Old As String, New As String)
	lbl.Text = reverse(New)
End Sub

Public Sub reverse(st As String ) As String
If st = "" Then Return ""
If st.Replace(" ","").Length <= 1 Then Return st

Dim str() As String = Regex.Split(" ",st)
If str.Length > 1 Then
	Dim acc As String = ""
	Dim st1 As String
	For i = 0 To str.Length - 1
		st1 = reverse(str(i)) 
		If st1.Length > 0 Then
			Dim q As Int = Asc(st1.CharAt(0)) 
			If q > Fromlimit AND q < Tolimit OR q>48 AND q < 57 Then
				acc = st1 & " " & acc
			Else
				acc = acc & " " & st1
			End If
		End If
	Next
	Return acc
Else
	Dim nst As String = ""
	Dim Cs As String
	Dim k As Int = Asc(st.Replace(" ","").CharAt(1)) ' 1 to cover cases "(text)"
	If k > Fromlimit AND k < Tolimit Then 'not Hebrew
		For i = 0 To st.Length - 1 
			Cs = st.CharAt(i)
			If Asc(Cs) = 40 Then	
				Cs = Chr(41)
			Else If Asc(Cs) = 41 Then
				Cs = Chr(40)
			End If
			nst = Cs & nst
		Next
		Return nst
	Else
		Return st
	End If
End If
End Sub